#include "Gui.ch"
#include "form1.frm"

/*
#define "Socket error 0 - Directly send error    "                                0
#define "Socket error 10004 - Interrupted function call "                        10004
#define "Socket error 10013 - Permission denied "                                10013
#define "Socket error 10014 - Bad address "                                      10014
#define "Socket error 10022 - Invalid argument "                                 10022
#define "Socket error 10024 - Too many open files "                              10024
#define "Socket error 10035 - Resource temporarily unavailable "                 10035
#define "Socket error 10036 - Operation now in progress "                        10036
#define "Socket error 10037 - Operation already in progress "                    10037
#define "Socket error 10038 - Socket operation on non-socket "                   10038
#define "Socket error 10039 - Destination address required "                     10039
#define "Socket error 10040 - Message too long "                                 10040
#define "Socket error 10041 - Protocol wrong type for socket "                   10041
#define "Socket error 10042 - Bad protocol option "                              10042
#define "Socket error 10043 - Protocol not supported "                           10043
#define "Socket error 10044 - Socket type not supported "                        10044
#define "Socket error 10045 - Operation not supported "                          10045
#define "Socket error 10046 - Protocol family not supported "                    10046
#define "Socket error 10047 - Address family not supported by protocol family "  10047
#define "Socket error 10048 - Address already in use "                           10048
#define "Socket error 10049 - Cannot assign requested address "                  10049
#define "Socket error 10050 - Network is down "                                  10050
#define "Socket error 10051 - Network is unreachable "                           10051
#define "Socket error 10052 - Network dropped connection on reset "              10052
#define "Socket error 10053 - Software caused connection abort "                 10053
#define "Socket error 10054 - Connection reset by peer "                         10054
#define "Socket error 10055 - No buffer space available "                        10055
#define "Socket error 10056 - Socket is already connected "                      10056
#define "Socket error 10057 - Socket is not connected "                          10057
#define "Socket error 10058 - Cannot send after socket shutdown "                10058
#define "Socket error 10060 - Connection timed out "                             10060
#define "Socket error 10061 - Connection refused "                               10061
#define "Socket error 10064 - Host is down "                                     10064
#define "Socket error 10065 - No route to host "                                 10065
#define "Socket error 10067 - Too many processes "                               10067
#define "Socket error 10091 - Network subsystem is unavailable "                 10091
#define "Socket error 10092 - WINSOCK.DLL version out of range "                 10092
#define "Socket error 10093 - Successful WSAStartup not yet performed "          10093
#define "Socket error 10094 - Graceful shutdown in progress "                    10094
#define "Socket error 11001 - Host not found "                                   11001
#define "Socket error 11002 - Non-authoritative host not found "                 11002
#define "Socket error 11003 - This is a non-recoverable error "                  11003
#define "Socket error 11004 - Valid name, no data record of requested type"      11004
*/


#define ssNotStarted                                                           0
#define ssClosed                                                               1
#define ssConnected                                                            2
#define ssListening                                                            3
#define ssOpen                                                                 4



/* * Evento OnClick. */
METHOD ConectarOnClick( oSender ) CLASS TForm1
If !Empty(Form1:Host:Caption)
   oTCPClient()
   oTCPClient():OnError   := { | | TCPClientHayError()   }
   oTCPClient():OnConnect := { | | TCPClientHayConnect() }
   oTCPClient():OnData    := { | | TCPClientHayData()    }
   oTCPClient():OnClose   := { | | TCPClientHayClose()   }
   oTCPClient():Host := Form1:Host:Caption
   oTCPClient():Port := Form1:Puerto:Caption 
   Form1:PanelEstado:Caption := "Conectando con  el Host:"+oTCPClient():Host+" en el Puerto:"+Var2String(oTCPCLient():Port)
   oTCPClient():Open()
   If oTCPClient():SocketState <> ssOpen
      Form1:PanelEstado:Caption := "ERROR!!!!Conectando con  el Host:"+oTCPClient():Host+" en el Puerto:"+Var2String(oTCPCLient():Port)
   Endif
Endif   
return

/* * Evento OnClick. */
METHOD DesconectarOnClick( oSender ) CLASS TForm1
Form1:PanelEstado:Caption := "Desconectando con  el Host:"+oTCPClient():Host+" en el Puerto:"+Var2String(oTCPCLient():Port)
oTCPClient():Close()
If oTCPClient():SocketState <> ssClosed
   Form1:PanelEstado:Caption := "ERROR!!!!Desconectando con  el Host:"+oTCPClient():Host+" en el Puerto:"+Var2String(oTCPCLient():Port)
Endif
Return


Function TCPClientHayError()
//OutPutDebug2( "Agente...........: " + oTCPClient():Agent )
OutPutDebug2( "Versin WinSocket: " + oTCPClient():Version )
OutPutDebug2( "Descripcin......: " + oTCPClient():Description )
OutPutDebug2( "Status...........: " + oTCPClient():SystemStatus )
OutPutDebug2( "" )
OutPutDebug2( "Host local.......: " + oTCPClient():LocalHostName )
OutPutDebug2( "IP local.........: " + oTCPClient():LocalHostAddress )
OutPutDebug2( "Local Port.......: " + Var2String(oTCPClient():LocalPort))
OutPutDebug2( "" )
OutPutDebug2( "Host Remoto......: " + oTCPClient():Host )
OutPutDebug2( "Puerto Remoto....: " + Var2String(oTCPClient():Port ))
OutPutDebug2("HAY ERROR.Estado variable SocketState:"+var2String(oTCPClient():SocketState))
OutPutDebug2("Estado TCPCLient:LastError:"+Var2String(oTCPClient():LastError))
return

Function TCPClientHayconnect()
OutPutDebug2("Hay CONNECT.Estado variable SocketState:"+var2String(oTCPClient():SocketState))
Form1:Conectar:Enabled := .F.
Form1:Desconectar:Enabled := .T.
return

Function TCPClientHayDATA()
OutPutDebug2("HAY DATA.Estado variable SocketState:"+var2String(oTCPClient():SocketState))
Aadd(Memo1:Lines,oTCPClient():Read())
return

Function TCPClientHayClose()
OutPutDebug2("HAY Close.Estado variable SocketState:"+var2String(oTCPClient():SocketState))
return

Function oTCPCLient()
Static oTCPCLient
If oTCPClient == NIL
   oTCPCLient := TTCPClient():Create()
Endif
Return oTCPClient

/*
 * Evento OnShow.
 */
METHOD Form1OnShow( oSender ) CLASS TForm1
Form1:Conectar:Enabled := .T.
Form1:Desconectar:Enabled := .F.
return